/**********************************************************************
  .SUF/.ATR to .POV converter                       1999-2000 TANE
  $Id:$
**********************************************************************/
#include	"common.h"
#include	"funcs.h"
#include	"filetype.h"
#include	"suf2pov.h"

#define	VERSION		"Ver 0.001 1999-2000"
#define	AUTHOR		"TANE"

#define	FNAME_LENG	1024
#define	FILE_NUM	64

unsigned char in_sufname[FILE_NUM][FNAME_LENG] ;
unsigned char in_atrname[FILE_NUM][FNAME_LENG] ;

void manprint() ;
int	 read_atr( unsigned char *, struct ATR_STRUCT *, int ) ;
int	 read_suf( unsigned char *, struct ATR_STRUCT *, int ) ;
int	 put_atr( struct ATR_STRUCT *, int ) ;

int main(int argc,char *argv[])
{
int		i ;
char	*workp ;
int		suf_fnum, atr_fnum ;
struct	ATR_STRUCT	atr[ATR_MAX] ;
int		atr_num ;

	suf_fnum=0 ;
	atr_fnum=0 ;
	for( i=1 ; i<argc ; i++){
		workp = argv[i] ;
		if( *workp == '-' ) {
			workp++ ;
			switch( *workp ){
				case 'h' :
				case 'H' :
				case '?' :
				manprint() ;
				exit(0) ;
			}
		}else{
			switch( get_ftype( argv[i] ) ){
				case SUF_FILE :
					strcpy( in_sufname[suf_fnum++] ,  argv[i] ) ;
					break ;
				case ATR_FILE :
					strcpy( in_atrname[atr_fnum++] ,  argv[i] ) ;
					break ;
			}
			if( suf_fnum==FILE_NUM || atr_fnum==FILE_NUM ){
				fprintf(stderr,"wt@Cő吔(=%d)𒴂܂\n",FILE_NUM) ;
				break ;
			}
		}
	}

	if( suf_fnum==0 && atr_fnum==0 ){
		manprint() ;
		exit(0) ;
	}

	atr_num=0 ;
	for( i=0 ; i<atr_fnum ; i++ ) atr_num += read_atr( in_atrname[i], atr, atr_num ) ;
	put_atr( atr, atr_num ) ;
	for( i=0 ; i<suf_fnum ; i++ ) read_suf( in_sufname[i] , atr , atr_num ) ;
	return(0) ;
}

void manprint()
{
	printf("DoGA .SUF to POV-Ray .pov converter " VERSION " " AUTHOR "\n");
	printf("Usage: suf2pov [.SUF|.ATR] ....\n");
	printf("  Options\n") ;
	printf("    -h,?   : wv\n");
}

