/**********************************************************************
  Read .SUF
  $Id:$
**********************************************************************/
#include	"common.h"
#include	"funcs.h"
#include	"suf2pov.h"

#define	POS_MAX		4096
#define	TYPE_POLY	0
#define	TYPE_SHADE	1

int	read_suf( unsigned char *fname, struct ATR_STRUCT *atr_pt, int atr_num )
{
unsigned char	str_line[TOKEN_STR_LEN] ;
FILE	*ifp ;
int	i ;
int     pos_is_last ;

int		getting_prim ;
struct	POS_STRUCT	pos[POS_MAX] ;
int		type , pos_num, pos_ptr ;

 token_pt = &token ;
 
 if( (ifp=fopen( fname , "rb" )) == NULL ){
   fprintf(stderr,"t@C %s I[vł܂\n",fname) ;
   return(FILE_OPEN_ERROR) ;
 }
 
 type = TYPE_POLY ;
 pos_num = 0 ;
 getting_prim=NO ;
 while( -1 ){
   if( fgets( str_line , TOKEN_STR_LEN , ifp )==NULL ) break ;
   if( feof(ifp)!=0 ) break ;
   if( get_token( str_line , token_pt )==0 ) continue ;
   
   if( strcmp(token_pt->pt[0],"obj")==0 ){
     printf("#declare %s_%s = object{\n",token_pt->pt[1],token_pt->pt[2]) ;
     printf("  mesh{\n") ; ;
     continue ;
   }
   if( strcmp(token_pt->pt[0],"}")==0 ){
     printf("  }\n") ;
     printf("}\n")   ;
     continue ;
   }
   
   if( strcmp(token_pt->pt[0],"prim")==0 ){
     pos_num=0 ;
     if( strcmp(token_pt->pt[1],"poly")==0 ){
       type=TYPE_POLY ;
       pos[pos_num].x =atof(token_pt->pt[3]) ;
       pos[pos_num].z =atof(token_pt->pt[4]) ;
       pos[pos_num].y =atof(token_pt->pt[5]) ;
     }else{
       type=TYPE_SHADE ;
       pos[pos_num].x =atof(token_pt->pt[3]) ;
       pos[pos_num].z =atof(token_pt->pt[4]) ;
       pos[pos_num].y =atof(token_pt->pt[5]) ;
       pos[pos_num].nx=atof(token_pt->pt[6]) ;
       pos[pos_num].nz=atof(token_pt->pt[7]) ;
       pos[pos_num].ny=atof(token_pt->pt[8]) ;
     }
     pos_num++ ;
     strcpy(atr_pt[atr_num].name,token_pt->pt[1]) ;
     getting_prim=YES ;
     continue ;
   }
   if( getting_prim==YES ){
     if( type==TYPE_POLY ){
       pos[pos_num].x =atof(token_pt->pt[0]) ;
       pos[pos_num].z =atof(token_pt->pt[1]) ;
       pos[pos_num].y =atof(token_pt->pt[2]) ;
     }else{
       type=TYPE_SHADE ;
       pos[pos_num].x =atof(token_pt->pt[0]) ;
       pos[pos_num].z =atof(token_pt->pt[1]) ;
       pos[pos_num].y =atof(token_pt->pt[2]) ;
       pos[pos_num].nx=atof(token_pt->pt[3]) ;
       pos[pos_num].nz=atof(token_pt->pt[4]) ;
       pos[pos_num].ny=atof(token_pt->pt[5]) ;
     }
     pos_num++ ;
     if( pos_num >=POS_MAX ){
       fprintf(stderr,"_VXeőlɒB܂\n") ;
       break ;
     }
     if( token_pt->num==4 || token_pt->num==7 ){
       pos_is_last=NO ;
       if( token_pt->num==4 && *token_pt->pt[3]==')' ) pos_is_last=YES ;
       if( token_pt->num==7 && *token_pt->pt[6]==')' ) pos_is_last=YES ;
       if( pos_is_last==YES ){
	 if( pos_num<3 ){
	   fprintf(stderr,"_3菭Ȃ\n") ;
	 }else{
	   for( i=0,pos_ptr=2 ; i<pos_num-2 ; i++,pos_ptr++ ){
	     if( type==TYPE_POLY ){
	       printf("      triangle{\n") ;
	       printf("        < %d , %d , %d >,",(int)pos[0        ].x,(int)pos[0        ].y,(int)pos[0        ].z) ;
	       printf("< %d , %d , %d >,",(int)pos[pos_ptr-1].x,(int)pos[pos_ptr-1].y,(int)pos[pos_ptr-1].z) ;
	       printf("< %d , %d , %d >\n",(int)pos[pos_ptr  ].x,(int)pos[pos_ptr  ].y,(int)pos[pos_ptr  ].z) ;
	     }else{
	       printf("      smooth_triangle{\n") ;
	       printf("        < %d , %d , %d >,< %d , %d , %d >,",
		      (int)pos[0].x ,(int)pos[0].y ,(int)pos[0].z,
		      (int)pos[0].nx,(int)pos[0].ny,(int)pos[0].nz) ;
	       printf("< %d , %d , %d >,< %d , %d , %d >,",
		      (int)pos[pos_ptr-1].x ,(int)pos[pos_ptr-1].y ,(int)pos[pos_ptr-1].z,
		      (int)pos[pos_ptr-1].nx,(int)pos[pos_ptr-1].ny,(int)pos[pos_ptr-1].nz) ;
	       printf("< %d , %d , %d >,< %d , %d , %d >\n",
		      (int)pos[pos_ptr].x ,(int)pos[pos_ptr].y ,(int)pos[pos_ptr].z,
		      (int)pos[pos_ptr].nx,(int)pos[pos_ptr].ny,(int)pos[pos_ptr].nz) ;
	     }
	     printf("      }\n") ;
	   }
	 }
	 getting_prim=NO ;
       }
     }
   }
 }
 
 fclose( ifp ) ;
 return( 0 ) ;
}

